//
//  AppDelegate.m
//  TICDemo
//
//  Created by jameskhdeng(邓凯辉) on 2018/5/11.
//  Copyright © 2018年 Tencent. All rights reserved.
//

#import "AppDelegate.h"
#import "JMToast.h"
#import "IMManager.h"
#import "TICDemoConst.h"
#import "UIApplication+XLUtils.h"
#import "BoardManager.h"

@interface AppDelegate () <V2TIMSDKListener>

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    BOOL sucess = [[IMManager sharedInstance] initSDK:(int)kSDKAppId listener:self];
    if (!sucess) {
        [[JMToast sharedToast] showDialogWithMsg:NSLocalizedString(@"IMInitFailed", nil)];
        
    }
    return YES;
}

-(void)dealloc {
    [[IMManager sharedInstance] unInit];
}

- (void)applicationWillResignActive:(UIApplication *)application {
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    //此代码为了保证程序退后台仍能收到IM消息
    __block UIBackgroundTaskIdentifier bgTaskID;
    bgTaskID = [application beginBackgroundTaskWithExpirationHandler:^ {
        //不管有没有完成，结束 background_task 任务
        [application endBackgroundTask: bgTaskID];
        bgTaskID = UIBackgroundTaskInvalid;
    }];
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
}


- (void)applicationWillTerminate:(UIApplication *)application {
}

#pragma mark - V2TIMSDKListener
/// 当前IM用户被踢下线，此时可以 UI 提示用户，并再次调用 V2TIMManager 的 login() 函数重新登录。
- (void)onKickedOffline {
    [[IMManager sharedInstance] kickout];
    [[BoardManager sharedInstance] destroyBoard];
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:NSLocalizedString(@"AccountKicked", nil) message:nil preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *action = [UIAlertAction actionWithTitle:NSLocalizedString(@"Confirm", nil) style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [(UINavigationController *)self.window.rootViewController popToRootViewControllerAnimated:YES];
    }];
    [alert addAction:action];
    UIViewController *currentVC = ((UINavigationController *)self.window.rootViewController).topViewController;
    [currentVC presentViewController:alert animated:YES completion:nil];
}

/// IM在线时票据过期：此时您需要生成新的 userSig 并再次调用 V2TIMManager 的 login() 函数重新登录。
- (void)onUserSigExpired {
    [[IMManager sharedInstance] kickout];
    [[BoardManager sharedInstance] destroyBoard];
    [[JMToast sharedToast] showDialogWithMsg:NSLocalizedString(@"TicketExpired", nil)];
    [(UINavigationController *)self.window.rootViewController popToRootViewControllerAnimated:YES];
}

- (UIInterfaceOrientationMask)supportedInterfaceOrientationsForWindow:(nullable UIWindow *)window {
    UIViewController *topVc = [[UIApplication sharedApplication] getCurrentViewController];
    if ([topVc isKindOfClass:NSClassFromString(@"TOCropViewController")]) {
        return UIInterfaceOrientationMaskPortrait;
    }
    return [topVc supportedInterfaceOrientations];
}

- (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(nullable UIWindow *)window {
    UIViewController *topVc = [[UIApplication sharedApplication] getCurrentViewController];
    if ([topVc isKindOfClass:NSClassFromString(@"TOCropViewController")]) {
        return UIInterfaceOrientationMaskPortrait;
    }
    return [topVc supportedInterfaceOrientations];
}
@end
