//
//  MenuTableViewController.h
//  TICDemo
//
//  Created by kennethmiao on 2019/4/25.
//  Copyright © 2019年 Tencent. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol MenuTableViewControllerDelegate <NSObject>
- (void)onSpeakerStateChaged:(BOOL)state;
//board（涂鸦）
- (void)onDrawStateChanged:(BOOL)state;
- (void)onSyncDataChanged:(BOOL)state;
- (void)onAddElementAutoSelect:(BOOL)state;
- (void)onMagicPenChanged:(NSInteger)index;
- (void)onMultiTouchChanged:(BOOL)state;
- (void)onDisableTouchChanged:(BOOL)state;
- (void)onPiecewiseErasureChanged:(BOOL)state;
- (void)onSelectToolType:(int)toolType;
- (void)onSelectGraphStyle:(int)style;
- (void)onSelectMathToolType:(int)toolType;
- (void)onSelectCustomGraph:(NSString *)url;
- (void)onSelectBrushColor:(UIColor *)color;
- (void)onSelectBackgroundColor:(UIColor *)color;
- (void)onSelectGlobalBackgroundColor:(UIColor *)color;
- (void)onBrushThinChanged:(float)thin;
- (void)onSelectTextColor:(UIColor *)color;
- (void)onSelectFluorescentColor:(UIColor *)color;
- (void)onTextSizeChanged:(float)thin;
- (void)onEraserSizeChanged:(float)size;
- (void)onTextHeightChanged:(float)height;
- (void)onSetBackgroundH5:(NSString *)url;
- (void)onAddH5File:(NSInteger)index;
- (void)onSetTextStyle:(int)style;
- (void)onSetTextFamily:(NSString *)family;
- (void)onAddMathBoard;
- (void)onSetMathGraphType:(NSInteger)type;
- (void)onSetOwnerNickNameVisible:(BOOL)state;
- (void)onAddAudio:(NSString *)url title:(NSString *)title;
- (void)onAddVideo;
- (void)onAddWatermark;
- (void)onExportInLocalMode;
- (void)onImportInLocalMode;
- (void)onExportInLocalModeWithFilter;
- (void)onImportInLocalModeWithFilter;
- (void)onHideElements;
- (void)onShowElements;
- (void)onSetPermission;
- (void)onUndo;
- (void)onRedo;
- (void)onSnapshot:(BOOL)full;
- (void)onClearBackground;
- (void)onClear;
- (void)onClearDraw;
- (void)onReset;
- (void)onSetBackgroundImage:(NSString *)path;
//board（白板）
- (void)onAddBoard:(NSInteger)index;
- (void)onDeleteBoard:(NSString *)boardId;
- (void)onGotoBoard:(NSString *)boardId resetStep:(BOOL)resetStep;
- (void)onPreBoard:(BOOL)resetStep;
- (void)onNextBoard:(BOOL)resetStep;
- (NSArray<NSString *> *)getBoardList;
- (NSString *)getCurrentBoard;
- (void)onPreStep;
- (void)onNextStep;
- (void)onBoardScaleChanged:(int)scale;
- (void)onBoardContentFitMode:(int)mode;
- (int)getBoardContentFitMode;
- (void)onBoardRatioChanged:(NSString *)ratio;
- (NSString *)getBoardRatio;
//board（文件）
- (void)onSwitchFile:(NSString *)fileId;
- (void)onDeleteFile:(NSString *)fileId;
- (NSArray<NSString *> *)getFileList;
- (NSString *)getCurrentFile;
- (void)onAddTranscodeFile;
- (void)onPlayPPTVideo;
- (void)onPausePPTVideo;
- (void)onPlayPPTAudio;
- (void)onPausePPTAudio;
@end

@interface MenuTableViewController : UITableViewController
@property (nonatomic, weak) id<MenuTableViewControllerDelegate> delegate;
- (void)setCanUndo:(BOOL)canUndo;
- (void)setCanRedo:(BOOL)canRedo;
- (void)setTextHeight:(float)value;
- (void)setEraserSize:(float)value;
@end

