//
//  UIApplication+XLUtils.m
//  XLSmallClass
//
//  Created by jiangyelin on 2020/12/29.
//  Copyright © 2020 XinLianXieTong. All rights reserved.
//

#import "UIApplication+XLUtils.h"

@implementation UIApplication (XLUtils)

- (UIViewController *)getCurrentViewController {
    UIViewController *root = [[UIApplication sharedApplication].delegate window].rootViewController;
    UIViewController *currentVC = [self getNextVC:root];
    return currentVC;
}

// 使用的递归方法
- (UIViewController *)getNextVC:(UIViewController *)rootVC {
    UIViewController *currentVC;
    if ([rootVC presentedViewController]) {
        rootVC = [rootVC presentedViewController];
    }
    
    // UITabBarController
    if ([rootVC isKindOfClass:[UITabBarController class]]) {
        currentVC = [self getNextVC:[(UITabBarController *)rootVC selectedViewController]];
    }
    // UINavigationController
    else if ([rootVC isKindOfClass:[UINavigationController class]]){
        currentVC = [self getNextVC:[(UINavigationController *)rootVC visibleViewController]];
    }
    // 普通的ViewController
    else {
        currentVC = rootVC;
    }
    return currentVC;
}

@end
